<?php
/**
 * @file
 * Extends the core of WOT class by handling basic methods and tries to ease
 * possible unnecessary requests.
 * @link http://www.mywot.com/en/terms/api
 */
 
class MyWOTDrupalClient extends MyWOTCore {

  const COMPONENT_ALL                 = NULL;
  const COMPONENT_TRUSTWORTHINESS     = 0;
  const COMPONENT_VENDOR_RELIABILITY  = 1;
  const COMPONENT_PRIVACY             = 2;
  const COMPONENT_CHILD_SAFETY        = 4;
  
  private $_data = NULL;
  private $_component = NULL;

  public function __construct() {
    // @todo: Load previsously queried hosts
    // @todo: Clean older than 30 minutes queries
  }
  
  public function get($host) {
    $data = $this->fetch($host);
    $this->_data = $data[$host];
    return $this;
  }
  
  public function trustworthiness() {
    $this->_set_component(MyWOTDrupalClient::COMPONENT_TRUSTWORTHINESS);
    return $this;
  }
  
  public function vendor_reliability() {
    $this->_set_component(MyWOTDrupalClient::COMPONENT_VENDOR_RELIABILITY);
    return $this;
  }
  
  public function privacy() {
    $this->_set_component(MyWOTDrupalClient::COMPONENT_PRIVACY);
    return $this;
  }
  
  public function child_safety() {
    $this->_set_component(MyWOTDrupalClient::COMPONENT_CHILD_SAFETY);
    return $this;
  }
  
  private function _set_component($component) {
    if (isset($this->_data->{$component})) {
      $this->_component = $this->_data->{$component};
    }
    return $this;
  }

  public function reputation() {

    // Return all components of given host
    if (is_null($this->_component)) {
      $return = array();
      foreach ($this->_data as $key => $value) {
        if (is_numeric($key)) {
          $return[$key] = $value[0];
        }
      }
      return $return;
    }
    else {
      return $this->_component[0];
    }

  }

  public function confidence() {

    // Return all components of given host
    if (is_null($this->_component)) {
      $return = array();
      foreach ($this->_data as $key => $value) {
        if (is_numeric($key)) {
          $return[$key] = $value[1];
        }
      }
      return $return;
    }
    else {
      return $this->_component[1];
    }

  }

}
